<?php
/**
 * @package Adsmanager
 * @subpackage AdsmanagerIconModule
 * @copyright	Copyright (C) 2010-2012 JoomPROD.com. All rights reserved.
 * @license GNU General Public License version 3, or later
 * @since 2.2
 * @version 1.0
 */

// Protect from unauthorized access
defined('_JEXEC') or die;

// Check for PHP4
if(defined('PHP_VERSION')) {
	$version = PHP_VERSION;
} elseif(function_exists('phpversion')) {
	$version = phpversion();
} else {
	// No version info. I'll lie and hope for the best.
	$version = '5.0.0';
}

// Old PHP version detected. EJECT! EJECT! EJECT!
if(!version_compare($version, '5.0.0', '>=')) return;

// Make sure Adsmanager is installed, otherwise bail out
if(!file_exists(JPATH_ADMINISTRATOR.'/components/com_adsmanager')) {
	return;
}

// Joomla! version check
if(version_compare(JVERSION, '2.5', 'lt') && version_compare(JVERSION, '1.6.0', 'ge')) {
	// Joomla! 1.6.x and 1.7.x: sorry fellas, no go.
	return;
}


// Make sure Adsmanager is enabled
jimport('joomla.application.component.helper');
if (!JComponentHelper::isEnabled('com_adsmanager', true))
{
	return;
}

// Load the language files
$lang =& JFactory::getLanguage();

// Initialize defaults
$image = "logo.png";
$label = JText::_('LBL_ADSADMIN');


if(version_compare(JVERSION, '1.6.0', 'ge')):?>
<div class="icon-wrapper" id="adsadminicon">
	<div class="atcpanel">
		<div class="icon">
			<a href="index.php?option=com_adsmanager&c=contents">
				<img src="../components/com_adsmanager/images/<?php echo $image ?>" />
				<span><?php echo $label; ?></span>
			</a>
		</div>
	</div>
</div>
<script lang="text/javascript">
	var adsmanagerIcon = $('adsadminicon');
	try {
		var adsmanagerIconParent = $('adsadminicon').getParent().getParent();
		if(adsmanagerIconParent.attributes.class.textContent == 'panel') {
			adsmanagerIconParent.setStyle('display','none');
		}
	} catch(e) {	
	}
<?php if(version_compare(JVERSION, '2.5.0', 'lt')): ?>
	try {
		$('cpanel').grab(adsmanagerIcon);
	} catch(e) {	
	}
<?php else: ?>
	try {
		$$('div.cpanel')[0].grab(adsmanagerIcon)
	} catch(e) {
	}
<?php endif; ?>
</script>
<?php else: ?>
<div class="atcpanel">
	<div style="float:<?php echo ($lang->isRTL()) ? 'right' : 'left'; ?>;">
		<div class="icon">
			<a href="index.php?option=com_adsmanager&c=contents">
				<img src="../components/com_adsmanager/images/<?php echo $image ?>" />
				<span><?php echo $label; ?></span>
			</a>
		</div>
	</div>
</div>
<?php endif; ?>